//EmClient.h : Declaration of the CEmClient

#ifndef __EmClient_H_
#define __EmClient_H_

#include <atlcom.h>
#include <commctrl.h>
#include <atlmisc.h>
#include "EmClientObject.h"

/////////////////////////////////////////////////////////////////////////////
// CEmClient
class CEmClient
	: public CWindowImpl<CEmClient, CAxWindow>
//	, public IDispEventImpl<0, CEmClient, &DIID__IEmClientEvents, &LIBID_EMCLIENTOBJECTLib, 1, 0>
//	, public IEmClient
{
public:
	CEmClient();
	virtual ~CEmClient();

	DECLARE_WND_SUPERCLASS(NULL, CAxWindow::GetWndClassName())

	HWND Create(LPCOLESTR lpszName = L"{B31C39C4-4122-4659-9FFC-EB98547834F8}", HWND hWndParent = NULL
				 ,RECT& rcPos = CRect(0,0,0,0), LPCTSTR szWindowName = "EmClient",
				DWORD dwStyle = WS_POPUP, DWORD dwExStyle = 0,
				UINT nID = 0, LPVOID lpCreateParam = NULL)
	{
//		m_hWnd = CWindow::Create(GetWndClassName(), hWndParent, rcPos, szWindowName, dwStyle, dwExStyle, nID, lpCreateParam);
//		m_hWnd = CAxWindow::Create(hWndParent, rcPos, szWindowName, dwStyle, dwExStyle);

		//Register Class
		WNDCLASSEX wcex;
		wcex.cbSize = sizeof(WNDCLASSEX); 
		wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		wcex.lpfnWndProc	= (WNDPROC)WndProc;
		wcex.cbClsExtra		= 0;
		wcex.cbWndExtra		= 0;
		wcex.hInstance		= _Module.GetModuleInstance();
		wcex.hIcon			= 0;
		wcex.hCursor		= 0;
		wcex.hbrBackground	= 0;
		wcex.lpszMenuName	= 0;
		wcex.lpszClassName	= "EmClientObject";
		wcex.hIconSm		= 0;
		ATOM atom = ::RegisterClassEx(&wcex);
		ATLASSERT(atom);
		m_hWnd = CWindow::Create(wcex.lpszClassName, hWndParent, rcPos, szWindowName, dwStyle, dwExStyle, nID, lpCreateParam);

		ATLASSERT(::IsWindow(m_hWnd));

		LPCTSTR lpszText1 = "EmClient component is not registered in your system.";
		LPCTSTR lpszText2 = "Create EmClient component failed";
		LPCTSTR lpszCaption = "EmClient";

		HRESULT hr = CreateControlEx(lpszName);
		if(!SUCCEEDED(hr))
		{
			MessageBox(lpszText1, lpszCaption, MB_ICONSTOP);
			ATLASSERT(FALSE);
			return NULL;
		}

		hr = QueryControl(&m_chat);
		if(!SUCCEEDED(hr))
		{
			MessageBox(lpszText2, lpszCaption, MB_ICONSTOP);
			ATLASSERT(FALSE);
			return NULL;
		}

		m_pemClient = NULL;
		hr = m_chat.QueryInterface(&m_pemClient);
		if(!SUCCEEDED(hr))
		{
			MessageBox(lpszText2, lpszCaption, MB_ICONSTOP);
			ATLASSERT(FALSE);
			return NULL;
		}
/*
		//EmClient events
		hr = QueryControl(&m_pIEmClientEventsQPtr);
		if (FAILED(hr))
		{
			ATLASSERT(FALSE);
			return 0;
		}
		hr = DispEventAdvise(m_pIEmClientEventsQPtr);
		if (FAILED(hr))
		{
			ATLASSERT(FALSE);
			return 0;
		}
*/
		return m_hWnd; 
	}
/*
	BEGIN_SINK_MAP(CEmClient)
		SINK_ENTRY_EX(0, DIID__IEmClientEvents, 1, Fire_StartSendAndReceive)
		SINK_ENTRY_EX(0, DIID__IEmClientEvents, 2, Fire_StopSendAndReceive)
	END_SINK_MAP()
*/
	STDMETHOD( EmClient)();
	STDMETHOD( Close)();
	STDMETHOD( NewMessage)(long lRecipientID);
	STDMETHOD( SendAndReceiveAll)(long lAccountID);
	STDMETHOD( AddressBook)();
	STDMETHOD( EmailMerge)(BSTR bstrAddressList);
	STDMETHOD( RegisterShellFileTypes)(BSTR bstrPathName);
	STDMETHOD( Message)(BSTR bstrMessageFileName);
	STDMETHOD( MessageID)(BSTR bstrMessageID);
	STDMETHOD( MailTo)(BSTR bstrAddress);
	STDMETHOD( MailAttach)(BSTR bstrFileName);

	virtual ULONG STDMETHODCALLTYPE Release()
	{
		Close();
		if(m_pemClient)
			m_pemClient->Release();
		m_pemClient = NULL;
		m_chat.Release();
/*
		if(::IsWindow(m_hWnd))
		{
			BOOL res = DestroyWindow();
			if(!res)
			{
				ATLASSERT(res);
				DWORD dwLastError = GetLastError();
			}
			m_hWnd = NULL;
		}
*/
		return 1;
	}

private:
	IEmClient* m_pemClient;
	CComPtr<IEmClient> m_chat;
	virtual void OnFinalMessage(HWND hWnd)
	{
//		if(m_pIEmClientEventsQPtr)
//			DispEventUnadvise(m_pIEmClientEventsQPtr);
	}

	BEGIN_MSG_MAP(CEmClient)
	END_MSG_MAP()
	static LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
	{
    return ::DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
};

#endif //__EmClient_H_