// maindlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINDLG_H__E0B9411A_8A47_4B5E_A771_21EC511845D2__INCLUDED_)
#define AFX_MAINDLG_H__E0B9411A_8A47_4B5E_A771_21EC511845D2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "MyEmClient.h"
#include "resource.h"
#include "regexp.h"

class CMainDlg : public CDialogImpl<CMainDlg>//, public CUpdateUI<CMainDlg>
//		, public CMessageFilter, public CIdleHandler
{
public:
	CMainDlg(LPTSTR lpstrCmdLine)
		:m_lpstrCmdLine(lpstrCmdLine)
	{
	}
	enum { IDD = IDD_MAINDLG };

	void StartSendAndReceive()
	{
		::EnableWindow(GetDlgItem(IDC_BTN_SEND_RECEIVE_ALL), FALSE);
	}

	void StopSendAndReceive()
	{
		::EnableWindow(GetDlgItem(IDC_BTN_SEND_RECEIVE_ALL), TRUE);
	}

	void CreateThread()
	{
		DWORD dwThreadID;
		HANDLE hThread = ::CreateThread(NULL, 0, RunThread, this, 0, &dwThreadID);
		if(hThread == NULL)
		{
			::MessageBox(NULL, _T("ERROR: Cannot create thread!!!"), _T("IO Mail"), MB_OK);
			return;
		}
	}

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAppAbout)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_ID_HANDLER(ID_EMCLIENT, OnEmClient)
		COMMAND_HANDLER(IDC_BTN_EMCLIENT, BN_CLICKED, OnClickedBtn_emclient)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_HANDLER(IDC_BTN_NEW_MESSAGE, BN_CLICKED, OnClickedBtn_new_message)
		COMMAND_HANDLER(IDC_BTN_SEND_RECEIVE_ALL, BN_CLICKED, OnClickedBtn_send_receive_all)
		COMMAND_HANDLER(IDC_BTN_ADDRESS_BOOK, BN_CLICKED, OnClickedBtn_address_book)
		COMMAND_HANDLER(IDC_BTN_HIDE, BN_CLICKED, OnClickedBtn_hide)
//		COMMAND_ID_HANDLER(ID_START_SEND_AND_RECEIVE, OnStartSendAndReceive)
//		COMMAND_ID_HANDLER(32768, OnStartSendAndReceive)
COMMAND_HANDLER(IDC_BTN_EMAIL_MERGE, BN_CLICKED, OnClickedBtn_email_merge)
	END_MSG_MAP()
private:
//	CMyEmClient m_emClient;
	CEmClient m_emClient;
	LPTSTR m_lpstrCmdLine;

	// thread proc
	static DWORD WINAPI RunThread(LPVOID lpData);

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// center the dialog on the screen
		CenterWindow();

		// set icons
		HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
		SetIcon(hIcon, TRUE);
		HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
			IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
		SetIcon(hIconSmall, FALSE);

		if((CString(m_lpstrCmdLine).Find("/REGSERVER") == 0) || (CString(m_lpstrCmdLine).Find("/UNREGSERVER") == 0))
		{
			//Wise installing/uninstalling
			EndDialog(IDOK);
			return 0;
		}

		if(!m_emClient.Create())
			return 0;

		MoveWindow(0,0,0,0);
		ShowWindow(SW_MINIMIZE);

//PostMessage(WM_COMMAND, IDC_BTN_EMCLIENT);
//::MessageBox(NULL, m_lpstrCmdLine, NULL, 0);
		if((CString(m_lpstrCmdLine).Find("/e") == 0) || CString(m_lpstrCmdLine).IsEmpty())
		{
			ShowWindow(SW_HIDE);
			CString strPathName;
			DWORD dwBufLength = ::GetModuleFileName(_Module.GetModuleInstance(), strPathName.GetBuffer(1024), 1024);
			ATLASSERT(dwBufLength);
			strPathName.ReleaseBuffer();
			ASSERT(!strPathName.IsEmpty());
			BSTR bstrPathName;
			bstrPathName = strPathName.AllocSysString();
			m_emClient.RegisterShellFileTypes(bstrPathName);
			::SysFreeString(bstrPathName);
		}

//		CreateThread();

		PostMessage(WM_COMMAND, ID_EMCLIENT);
		
		return TRUE;
	}

	void RunEmClient()
	{
		if(!m_hWnd)
		{
			if((CString(m_lpstrCmdLine).Find("/REGSERVER") == 0) || (CString(m_lpstrCmdLine).Find("/UNREGSERVER") == 0))
			{
				//Wise installing/uninstalling
				EndDialog(IDOK);
				return;
			}

			if(!m_emClient.Create())
				return;
		}

		LPTSTR lpstrCmdLine = m_lpstrCmdLine;
		if(CString(lpstrCmdLine) == "/t")
		{
			ShowWindow(SW_RESTORE);
			return; //Opens the Test dialog box
		}

		if(m_hWnd)
		{
			ATLASSERT(::IsWindow(m_hWnd));
			ShowWindow(SW_HIDE);
		}
		if((CString(lpstrCmdLine).Find("/e") == 0) || CString(lpstrCmdLine).IsEmpty())
		{
			m_emClient.EmClient();//The Main window of the EmClient opens.
		}
		else if(CString(lpstrCmdLine).Find("/n ") == 0)
		{//The New Message window opens
			CString strCmdLine = lpstrCmdLine;
			CString strRecipientID;
			Regexp Re("/n ([123456789]*)");
			ATLASSERT(Re.CompiledOK());
			if(Re.Match(strCmdLine) && (Re.SubStrings() == 1))
				strRecipientID = Re[1];
			long lRecipientID = 0;
			if(!strRecipientID.IsEmpty())
				lRecipientID = ::atol(strRecipientID);
			m_emClient.NewMessage(lRecipientID);
		}
		else if(CString(lpstrCmdLine).Find("/mailurl") == 0)
		{//The New Message window with recipient opens
			CString strCmdLine = lpstrCmdLine;
			BSTR bstrCmdLine;
			bstrCmdLine = strCmdLine.AllocSysString();
			m_emClient.MailTo(bstrCmdLine);
			::SysFreeString(bstrCmdLine);
		}
		else if(CString(lpstrCmdLine).Find("/f ") == 0)
		{//The New Message window with attached file opens
			CString strCmdLine = lpstrCmdLine;
			Regexp Re("/f (.*)");
			ATLASSERT(Re.CompiledOK());
			if(Re.Match(strCmdLine) && (Re.SubStrings() == 1))
			{
				CString strFileName = Re[1];
				BSTR bstrFileName;
				bstrFileName = strFileName.AllocSysString();
				m_emClient.Message(bstrFileName);
				::SysFreeString(bstrFileName);
			}
			else
				AfxMessageBox("ERROR; Email of the file failed. File name is empty.");
		}
		else if(CString(lpstrCmdLine).Find("/p ") == 0)
		{//Send and receive messages. The Progress dialog opens
			CString strCmdLine = lpstrCmdLine;
			CString strAccountID;
			Regexp Re("/p ([123456789]*)");
			ATLASSERT(Re.CompiledOK());
			if(Re.Match(strCmdLine) && (Re.SubStrings() == 1))
				strAccountID = Re[1];
			long lAccountID = 0;
			if(!strAccountID.IsEmpty())
				lAccountID = ::atol(strAccountID);
			m_emClient.SendAndReceiveAll(lAccountID);
		}
		else if(CString(lpstrCmdLine).Find("/m") == 0)
		{//View a message
			CString strCmdLine = lpstrCmdLine;
			BSTR bstrCmdLine;
			bstrCmdLine = strCmdLine.AllocSysString();
			m_emClient.MessageID(bstrCmdLine);
			::SysFreeString(bstrCmdLine);
		}
		else if(CString(lpstrCmdLine).Find("/a") == 0)
		{//The Address Book opens
			m_emClient.AddressBook();
		}
		else
		{
			CString strCmdLine = lpstrCmdLine;
			BSTR bstrCmdLine;
			bstrCmdLine = strCmdLine.AllocSysString();
			m_emClient.MailAttach(bstrCmdLine);
			::SysFreeString(bstrCmdLine);
		}
		m_emClient.Release();
		if(m_hWnd)
		{
			ATLASSERT(::IsWindow(m_hWnd));
			EndDialog(IDOK);
		}
	}

	LRESULT OnAppAbout(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CSimpleDialog<IDD_ABOUTBOX, FALSE> dlg;
		dlg.DoModal();
		return 0;
	}

	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		// TODO: Add validation code 
		EndDialog(wID);
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}
	LRESULT OnEmClient(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		CreateThread();
//		m_emClient.EmClient();
		return 0;
	}
	LRESULT OnClickedBtn_hide(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		ShowWindow(SW_HIDE);
		return 0;
	}
	LRESULT OnClickedBtn_emclient(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		m_emClient.EmClient();
		return 0;
	}
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_emClient.Release();
		if(::IsWindow(m_emClient.m_hWnd))
		{
			BOOL res = m_emClient.DestroyWindow();
			if(!res)
			{
				ATLASSERT(res);
				DWORD dwLastError = GetLastError();
			}
			m_emClient.m_hWnd = NULL;
		}
		return 0;
	}
	LRESULT OnClickedBtn_new_message(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		const int nMaxCount = 256;
		CString str;
		GetDlgItemText(IDC_EDIT_RECIPIENT_ID, str.GetBuffer(nMaxCount), nMaxCount);
		str.ReleaseBuffer();
		m_emClient.NewMessage(::atol(str));
		return 0;
	}
	LRESULT OnClickedBtn_send_receive_all(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		const int nMaxCount = 256;
		CString str;
		GetDlgItemText(IDC_EDIT_ACCOUNT_ID, str.GetBuffer(nMaxCount), nMaxCount);
		str.ReleaseBuffer();
		m_emClient.SendAndReceiveAll(::atol(str));
		return 0;
	}
	LRESULT OnClickedBtn_address_book(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		m_emClient.AddressBook();
		return 0;
	}
	LRESULT OnClickedBtn_email_merge(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		const int nMaxCount = 256;
		CString str;
		GetDlgItemText(IDC_EDIT_ADDRESS_LIST, str.GetBuffer(nMaxCount), nMaxCount);
		str.ReleaseBuffer();
		BSTR bstr = str.AllocSysString();
		m_emClient.EmailMerge(bstr);
		::SysFreeString(bstr);
		return 0;
	}
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__E0B9411A_8A47_4B5E_A771_21EC511845D2__INCLUDED_)
