//MyAfx.cpp

#include "stdafx.h"
//#include "MyAfx.h"

#include "resource.h"
#include <atlmisc.h>

HINSTANCE afxCurrentInstanceHandle = NULL;

int AfxMessageBox(LPCTSTR lpszText, UINT nType, HWND hParent)
{
	CString strCaption;
	strCaption.LoadString(IDR_MAINFRAME);

//	HWND hWnd = g_hMainWnd;
	HWND hWnd = ::GetActiveWindow();
	if(hParent)
		hWnd = hParent;
	if(!hWnd)
		hWnd = ::GetDesktopWindow();
	ATLASSERT(::IsWindow(hWnd));
	return ::MessageBox(hWnd, lpszText, strCaption, nType);

//	return ::MessageBox(::GetActiveWindow(), lpszText, strCaption, nType | MB_SYSTEMMODAL);
}

int AfxMessageBox(UINT nIDPrompt, UINT nType, HWND hParent)
{
	CString string;
	if (!string.LoadString(nIDPrompt))
	{
		ATLTRACE("Error: failed to load message box prompt string 0x%04x.\n",
			nIDPrompt);
		ATLASSERT(FALSE);
	}
	return AfxMessageBox(string, nType, hParent);
}

int FormatMessageBox(UINT nType, LPCTSTR lpszFormat, ...)
{
	va_list args;
	va_start(args, lpszFormat);

	int nBuf;
	char szBuffer[4024];

	nBuf = _vsnprintf(szBuffer, sizeof(szBuffer), lpszFormat, args);
	va_end(args);
	return AfxMessageBox(szBuffer, nType);
}
/*
int FormatMessageBox(UINT nType, UINT nIDPrompt, ...)
{
	const int nBufferMax = 4024;
	char szBufferFormat[nBufferMax];
	VERIFY(::LoadString(_Module.GetResourceInstance(), nIDPrompt, szBufferFormat, nBufferMax));
	LPCTSTR lpszFormat = szBufferFormat;
	va_list args;
	va_start(args, lpszFormat);

	int nBuf;
	char szBuffer[4024];

	nBuf = _vsnprintf(szBuffer, sizeof(szBuffer), lpszFormat, args);
	va_end(args);
	return AfxMessageBox(szBuffer, nType);
}
*/
//_AFXWIN_INLINE HINSTANCE AFXAPI AfxGetInstanceHandle()
HINSTANCE AfxGetInstanceHandle()
{
	ASSERT(afxCurrentInstanceHandle != NULL);
	return afxCurrentInstanceHandle;
}

/////////////////////////////////////////////////////////////////////////////
// Additional helpers for WNDCLASS init

// like RegisterClass, except will automatically call UnregisterClass
//BOOL AFXAPI AfxRegisterClass(WNDCLASS* lpWndClass)
BOOL AfxRegisterClass(WNDCLASS* lpWndClass)
{
	WNDCLASS wndcls;
	if (GetClassInfo(lpWndClass->hInstance, lpWndClass->lpszClassName,
		&wndcls))
	{
		// class already registered
		return TRUE;
	}

	if (!::RegisterClass(lpWndClass))
	{
		TRACE1("Can't register window class named %s\n",
			lpWndClass->lpszClassName);
		return FALSE;
	}
/*
	if (afxContextIsDLL)
	{
		AfxLockGlobals(CRIT_REGCLASSLIST);
		TRY
		{
			// class registered successfully, add to registered list
			AFX_MODULE_STATE* pModuleState = AfxGetModuleState();
			LPTSTR lpszUnregisterList = pModuleState->m_szUnregisterList;
			// the buffer is of fixed size -- ensure that it does not overflow
			ASSERT(lstrlen(lpszUnregisterList) + 1 +
				lstrlen(lpWndClass->lpszClassName) + 1 <
				_countof(pModuleState->m_szUnregisterList));
			// append classname + newline to m_szUnregisterList
			lstrcat(lpszUnregisterList, lpWndClass->lpszClassName);
			TCHAR szTemp[2];
			szTemp[0] = '\n';
			szTemp[1] = '\0';
			lstrcat(lpszUnregisterList, szTemp);
		}
		CATCH_ALL(e)
		{
			AfxUnlockGlobals(CRIT_REGCLASSLIST);
			THROW_LAST();
			// Note: DELETE_EXCEPTION not required.
		}
		END_CATCH_ALL
		AfxUnlockGlobals(CRIT_REGCLASSLIST);
	}
*/
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Diagnostic Trace

//void AFX_CDECL AfxTrace(LPCTSTR lpszFormat, ...)
void AfxTrace(LPCTSTR lpszFormat, ...)
{
/*
#ifdef _DEBUG // all AfxTrace output is controlled by afxTraceEnabled
	if (!afxTraceEnabled)
		return;
#endif
*/
	va_list args;
	va_start(args, lpszFormat);

	int nBuf;
	TCHAR szBuffer[512];

//	nBuf = _vsntprintf(szBuffer, _countof(szBuffer), lpszFormat, args);
	nBuf = _vsntprintf(szBuffer, sizeof(szBuffer), lpszFormat, args);

	// was there an error? was the expanded string too long?
	ASSERT(nBuf >= 0);

//	if ((afxTraceFlags & traceMultiApp) && (AfxGetApp() != NULL))
//		afxDump << AfxGetApp()->m_pszExeName << ": ";
//	afxDump << szBuffer;

	va_end(args);
}

// resource failure
//void AFXAPI AfxThrowResourceException()
void AfxThrowResourceException()
{
//	THROW((CResourceException*)&_simpleResourceException);
	throw;
}

//BOOL AFXAPI AfxEnableMemoryTracking(BOOL bTrack)
BOOL AfxEnableMemoryTracking(BOOL bTrack)
{
/*
	if (_afxMemoryLeakOverride)
		return TRUE;

	int nOldState = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
	if (bTrack)
		_CrtSetDbgFlag(nOldState | _CRTDBG_ALLOC_MEM_DF);
	else
		_CrtSetDbgFlag(nOldState & ~_CRTDBG_ALLOC_MEM_DF);
	return nOldState & _CRTDBG_ALLOC_MEM_DF;
*/
	return TRUE;
}

//void AFXAPI AfxHookWindowCreate(CWnd* pWnd)
void AfxHookWindowCreate(CWnd* pWnd)
{
/*
	_AFX_THREAD_STATE* pThreadState = _afxThreadState.GetData();
	if (pThreadState->m_pWndInit == pWnd)
		return;

	if (pThreadState->m_hHookOldCbtFilter == NULL)
	{
		pThreadState->m_hHookOldCbtFilter = ::SetWindowsHookEx(WH_CBT,
			_AfxCbtFilterHook, NULL, ::GetCurrentThreadId());
		if (pThreadState->m_hHookOldCbtFilter == NULL)
			AfxThrowMemoryException();
	}
	ASSERT(pThreadState->m_hHookOldCbtFilter != NULL);
	ASSERT(pWnd != NULL);
	ASSERT(pWnd->m_hWnd == NULL);   // only do once

	ASSERT(pThreadState->m_pWndInit == NULL);   // hook not already in progress
	pThreadState->m_pWndInit = pWnd;
*/
}

//BOOL AFXAPI AfxUnhookWindowCreate()
BOOL AfxUnhookWindowCreate()
{
/*
	_AFX_THREAD_STATE* pThreadState = _afxThreadState.GetData();
#ifndef _AFXDLL
	if (afxContextIsDLL && pThreadState->m_hHookOldCbtFilter != NULL)
	{
		::UnhookWindowsHookEx(pThreadState->m_hHookOldCbtFilter);
		pThreadState->m_hHookOldCbtFilter = NULL;
	}
#endif
	if (pThreadState->m_pWndInit != NULL)
	{
		pThreadState->m_pWndInit = NULL;
		return FALSE;   // was not successfully hooked
	}
*/
	return TRUE;
}

BOOL AfxIsValidAddress( const void* lp, UINT nBytes, BOOL bReadWrite)
{
	return TRUE;
}

